use crate::Link;
use crate::searchers::Searcher;

use scryfall;
use scryfall::Card;

//use retry::retry;
//use retry::delay::Fixed;

use mopa::Any;

// const NUM_RETRIES: usize = 10;
// const RETRY_WAIT_MILLIS: u64 = 500;

pub type MtgCard = Card;

impl Link for Card {
    fn label (&self) -> &str {
        &self.name
    }

    fn url (&self) -> &str {
        self.scryfall_uri.as_str()
    }

    fn as_any (&self) -> &dyn Any {
        self
    }
}

pub struct MtgSearcher {}

impl MtgSearcher {
    pub fn new () -> MtgSearcher{
        MtgSearcher {}
    }
}

impl Searcher<Card> for MtgSearcher {
    fn exact_search (&self, name: &str) -> Option<Card> {
        Card::named(name).ok()
    }
}
